"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const AuthContext_1 = __importDefault(require("./AuthContext"));
const OrdersContext_1 = __importDefault(require("./OrdersContext"));
const ConfigContext_1 = __importDefault(require("./ConfigContext"));
const orderingCore = __importStar(require("@orderingstack/ordering-core"));
function OrderWrapper(props) {
    const _configContext = react_1.useContext(ConfigContext_1.default);
    if (!_configContext) {
        return (react_1.default.createElement(react_1.Fragment, null, "Configuration shoud be provided"));
    }
    const config = _configContext;
    const [orders, setOrders] = react_1.useState({});
    const { authProvider } = react_1.useContext(AuthContext_1.default);
    const onOrdersUpdated = (order, allOrders) => {
        //console.log("--------------" + Object.keys(allOrders).length);
        setOrders(Object.assign({}, allOrders));
    };
    function setOrderChangesListener(authProvider) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { token } = yield authProvider();
                if (token) {
                    orderingCore.orderChangesListener(config.baseUrl, config.tenant, config.venue, authProvider, onOrdersUpdated, () => {
                        setOrders({});
                    }, config.enableKDS);
                }
            }
            catch (err) {
                setOrders({});
            }
        });
    }
    react_1.useEffect(() => {
        orderingCore.setOrderStoreUpdatedCallback(onOrdersUpdated);
        setOrderChangesListener(authProvider);
    }, []);
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(OrdersContext_1.default.Provider, { value: orders }, props.children)));
}
exports.default = OrderWrapper;
